<?php
/**
 * Webkul MarketingCloud Magento Product Controller
 * @category  Webkul
 * @package   Webkul_MarketingCloudMagentoConnector
 * @author    Webkul
 * @copyright Copyright (c) 2010-2017 Webkul Software Private Limited (https://webkul.com)
 * @license   https://store.webkul.com/license.html
 */
namespace Webkul\MarketingCloudMagentoConnector\Controller\Adminhtml;

abstract class Product extends \Magento\Backend\App\AbstractAction
{
    /**
     * Core registry
     *
     * @var \Magento\Framework\Registry
     */
    protected $_coreRegistry;

    /**
     * User model factory
     *
     * @var \Magento\User\Model\UserFactory
     */
    protected $_userFactory;

    /**
     * Product model factory
     *
     * @var \Webkul\MarketingCloudMagentoConnector\Model\ProductFactory
     */
    protected $_productFactory;

    /**
     * @param \Magento\Backend\App\Action\Context $context
     * @param \Magento\Framework\Registry $coreRegistry
     * @param \Magento\User\Model\UserFactory $userFactory
     * @param \Webkul\MarketingCloudMagentoConnector\Model\ProductFactory $productFactory
     */
    public function __construct(
        \Magento\Framework\Registry $coreRegistry,
        \Magento\Catalog\Model\Product $catalogModel,
        \Magento\User\Model\UserFactory $userFactory,
        \Magento\Backend\App\Action\Context $context,
        \Webkul\MarketingCloudMagentoConnector\Helper\Connection $connection
    ) {
        parent::__construct($context);
        $this->_connection = $connection;
        $this->_userFactory = $userFactory;
        $this->_coreRegistry = $coreRegistry;
        $this->_catalogModel = $catalogModel;
    }

    /**
     * @return $this
     */
    protected function _initAction()
    {
        $this->_view->loadLayout();
        $this->_setActiveMenu(
            'Webkul_MarketingCloudMagentoConnector::manager'
        );
        return $this;
    }
}
