<?php
/**
 * Webkul MarketingCloud Magento Connector SyncCustomer Controller
 * @category  Webkul
 * @package   Webkul_MarketingCloudMagentoConnector
 * @author    Webkul
 * @copyright Copyright (c) 2010-2017 Webkul Software Private Limited (https://webkul.com)
 * @license   https://store.webkul.com/license.html
 */
namespace Webkul\MarketingCloudMagentoConnector\Controller\Adminhtml\Subscriber;

class ExportToMc extends \Magento\Backend\App\Action
{
    protected $subscriberFactory;
    protected $messageManager;


    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \Magento\Framework\Message\ManagerInterface $messageManager,
        \Magento\Newsletter\Model\SubscriberFactory $subscriberFactory,
        \Webkul\MarketingCloudMagentoConnector\Helper\Connection $connection,
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig
    ) {
        parent::__construct($context);
        $this->subscriberFactory= $subscriberFactory;
        $this->messageManager = $messageManager;
        $this->_connection = $connection;
        $this->_scopeConfig = $scopeConfig;
    }

    public function execute()
    {
     
        $helper = $this->_connection;
        $sessionToken = $this->_session->getMarketingToken();
        $token = $this->_scopeConfig->getValue('marketingcloud/general/mc_conn_token');
        $relToken = $helper->genarateToken();
        if(isset($token) && $token != null){
            $sessionToken = $token;
        }
        if ($sessionToken != $relToken) {
            $resultRedirect = $this->resultRedirectFactory->create();
            $this->messageManager->addError(__("Licence Invalid, Kindly use correct licence key!!!"));
            return $this->_redirect('newsletter/subscriber/index');
        }
        $subscribersIds = $this->getRequest()->getParam('subscriber');
        if (!is_array($subscribersIds)) {
            $this->messageManager->addErrorMessage(__('Please select one or more subscribers.'));
        } else {
            $res = $helper->SyncSubscriberToList($subscribersIds);
            if($res && $res[0]){
                $message = "Subscriber(s) added to the  selected list Successfully!!";
                $this->messageManager->addSuccess(__($message));
            } else{
                $this->messageManager->addError(__("Please select the list in marketing cloud configuration."));
            }
        }
        return $this->_redirect('newsletter/subscriber/index');
    }
}
