<?php
namespace Webkul\MarketingCloudMagentoConnector\Controller\Adminhtml\Subscriber;

/**
* Webkul MarketingCloudMagentoConnector Index Controller
* @category  Webkul
* @package   Webkul_MarketingCloudMagentoConnector
* @author    Webkul
* @copyright Copyright (c) 2010-2017 Webkul Software Private Limited (https://webkul.com)
* @license   https://store.webkul.com/license.html
*/

use Magento\Backend\App\Action\Context;
use Magento\Framework\View\Result\PageFactory;

class Index extends \Magento\Backend\App\Action
{
    const ADMIN_RESOURCE = 'Webkul_MarketingCloudMagentoConnector::manager';

    /**
     * @var PageFactory
     */
    protected $_resultPageFactory;

    /**
     * @param Context $context
     * @param PageFactory $resultPageFactory
     */
    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory
    ) {
        parent::__construct($context);
        $this->_resultPageFactory = $resultPageFactory;
    }

    /**
     * Index action
     *
     * @return \Magento\Backend\Model\View\Result\Page
     */
    public function execute()
    {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $configObj = $objectManager->create("Magento\Framework\App\Config\ScopeConfigInterface");
        $helperObj = $objectManager->create("\Webkul\MarketingCloudMagentoConnector\Helper\Connection");
        $sessionToken = $this->_session->getMarketingToken();
        $token = $configObj->getValue('marketingcloud/general/mc_conn_token');
        $relToken = $helperObj->genarateToken();
        if(isset($token) && $token != null){
            $sessionToken = $token;
        }
        if ($sessionToken != $relToken) {
            $resultRedirect = $this->resultRedirectFactory->create();
            $this->messageManager->addError(__("Licence Invalid, Kindly use correct licence key!!!"));
            return $resultRedirect->setPath('adminhtml/system_config/edit/section/marketingcloudmagentoconnector');
        }
        /** @var \Magento\Backend\Model\View\Result\Page $resultPage */
        $resultPage = $this->_resultPageFactory->create();
        $resultPage->setActiveMenu('Webkul_MarketingCloudMagentoConnector::manager');
        $resultPage->addBreadcrumb(
            __(
                'MarketingCloudMagentoConnector Subscriber'
            ),
            __(
                'MarketingCloudMagentoConnector Subscriber'
            )
        );
        $resultPage->getConfig()->getTitle()->prepend(__('Subscriber List'));

        return $resultPage;
    }

    protected function _isAllowed()
    {
        return $this->_authorization->isAllowed('Webkul_MarketingCloudMagentoConnector::subscriber_list');
    }
}
