<?php
/**
 * Webkul MarketingCloudMagentoConnector Attribute Model
 * @category  Webkul
 * @package   Webkul_MarketingCloudMagentoConnector
 * @author    Webkul
 * @copyright Copyright (c) 2010-2017 Webkul Software Private Limited (https://webkul.com)
 * @license   https://store.webkul.com/license.html
 */
namespace Webkul\MarketingCloudMagentoConnector\Model;

use Webkul\MarketingCloudMagentoConnector\Api\Data\SubscriberInterface;
use Magento\Framework\DataObject\IdentityInterface;

class Subscriber extends \Magento\Framework\Model\AbstractModel implements SubscriberInterface, IdentityInterface
{

    protected $interfaceMytables = [

        //SubscriberInterface::ENTITY_ID,
        SubscriberInterface::MC_SUBSLISTID,
        SubscriberInterface::MC_SUBSLISTNAME,
        SubscriberInterface::MC_SUBSID,
        SubscriberInterface::MC_SUBSEMAIL,
        SubscriberInterface::MCSUBSKEY,
    ];
    /**#@+
     * Post's Statuses
     */
    const STATUS_ENABLED = 1;
    const STATUS_DISABLED = 0;
    /**#@-*/

    /**
     * CMS page cache tag
     */
    const CACHE_TAG = 'marketingcloudmagentoconnector_subscriber';

    /**
     * @var string
     */
    protected $_cacheTag = 'marketingcloudmagentoconnector_subscriber';

    /**
     * Prefix of model events names
     *
     * @var string
     */
    protected $_eventPrefix = 'marketingcloudmagentoconnector_subscriber';

    /**
     * Initialize resource model
     *
     * @return void
     */
    protected function _construct()
    {
        $this->_init('Webkul\MarketingCloudMagentoConnector\Model\ResourceModel\Subscriber');
    }
    /**
     * Prepare post's statuses.
     * Available event to customize statuses.
     *
     * @return array
     */
    public function getAvailableStatuses()
    {
        return [self::STATUS_ENABLED => __('Enabled'), self::STATUS_DISABLED => __('Disabled')];
    }
    /**
     * Return unique ID(s) for each object in system
     *
     * @return array
     */
    public function getIdentities()
    {
        return [self::CACHE_TAG . '_' . $this->getId()];
    }

    /**
     * Get EntityId.
     *
     * @return int
     */
    // public function getEntityId()
    // {
    //     return $this->getData(self::ENTITY_ID);
    // }

    /**
     * Set EntityId.
     */
    // public function setEntityId($entityId)
    // {
    //     return $this->setData(self::ENTITY_ID, $entityId);
    // }

    /**
     * Get McSubsListId.
     *
     * @return varchar
     */
    public function getMcSubsListId()
    {
        return $this->getData(self::MC_SUBSLISTID);
    }

    /**
     * Set McSubsListId.
     */
    public function setMcSubsListId($mcSubsListId)
    {
        return $this->setData(self::MC_SUBSLISTID, $mcSubsListId);
    }

    /**
     * Get McSubsListName.
     *
     * @return varchar
     */
    public function getMcSubsListName()
    {
        return $this->getData(self::MC_SUBSLISTNAME);
    }

    /**
     * Set McSubsListName.
     */
    public function setMcSubsListName($mcSubsListName)
    {
        return $this->setData(self::MC_SUBSLISTNAME, $mcSubsListName);
    }

    /**
     * Get McSubsId.
     *
     * @return varchar
     */
    public function getMcSubsId()
    {
        return $this->getData(self::MC_SUBSID);
    }

    /**
     * Set McSubsId.
     */
    public function setMcSubsId($mcSubsId)
    {
        return $this->setData(self::MC_SUBSID, $mcSubsId);
    }

    /**
     * Get McSubsEmail.
     *
     * @return varchar
     */
    public function getMcSubsEmail()
    {
        return $this->getData(self::MC_SUBSEMAIL);
    }

    /**
     * Set McSubsEmail.
     */
    public function setMcSubsEmail($mcSubsEmail)
    {
        return $this->setData(self::MC_SUBSEMAIL, $mcSubsEmail);
    }

    /**
     * Get McSubsKey.
     *
     * @return varchar
     */
    public function getMcSubsKey()
    {
        return $this->getData(self::MCSUBSKEY);
    }

    /**
     * Set McSubsKey.
     */
    public function setMcSubsKey($mcSubsKey)
    {
        return $this->setData(self::MCSUBSKEY, $mcSubsKey);
    }

    /**
     * Get CreatedAt.
     *
     * @return varchar
     */
    // public function getCreatedAt()
    // {
    //     return $this->getData(self::CREATED_AT);
    // }

    /**
     * Set CreatedAt.
     */
    // public function setCreatedAt($createdAt)
    // {
    //     return $this->setData(self::CREATED_AT, $createdAt);
    // }
}
